/*
Scrivere un programma per la gestione degli studenti e delle prenotazioni degli esami.
Gli studenti sono caratterizzati dalle seguenti informazioni: cognome, nome, matricola codice corso di laurea (0..3).
Le prenotazioni sono caratterizzate dalle seguenti informazioni: matricola studente, codice materia (0..9), giorno dellesame, corso di laurea (0..3). 
Gli studenti sono inseriti in un vettore di 4 liste,  una per ogni corso di laurea. 
Le prenotazioni sono inserite in una tabella allocata dinamicamente avente 10 righe, una  per materia.

Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1. Inserimento ordinato rispetto alla matricola nel vettore di liste di una nuovo studente; 
2. Visualizzazione degli studenti di un corso di laurea;
3. Inserimento di una nuova prenotazione;
4. Ricerca di una prenotazione (chiedere matricola e materia);
5. Salvataggio su file delle prenotazioni;
6. Lettura da file delle prenotazioni precedentemente salvate e inserimento in tabella;

Liberare la memoria allocata dinamicamente.

*/


#include<stdio.h>
#include<stdlib.h>

struct studente {
        char cognome [20], nome [20];
        long matricola;
        int corso;
        } ;
        
struct prenotazione {
        long matricola;
        int materia, corso;
        char data [12];
        };
        
struct atomo {
       struct studente dato;
       struct atomo *next;
       };


void leggi_studente (struct studente *s);
void ins_studente (struct atomo **ptl, struct studente s);
void vis_studenti (struct atomo *ptl);
void leggi_prenotazione (struct prenotazione *p);
void ins_prenotazione (struct prenotazione **R, int *n, struct prenotazione p);
void ricerca (struct prenotazione *R, int n, long m);
void salva (struct prenotazione *TB[10], int *N);
void leggi_file (struct prenotazione *TB[10], int *N);
void da_testa (struct atomo **ptl);

       
main()
{
      struct atomo *L[4];
      struct prenotazione *T[10], x;
      struct studente s;
      int N[10], scelta, i;
      long matricola;
      
      for(i=0;i<4;i++)
          L[i]=NULL;
          
      for(i=0;i<10;i++)
      {
                       T[i]=NULL;
                       N[i]=0;
      }
      
      do{
                       printf("\nScegli tra\n");
                       printf("1)Inserimento studente\n");
                       printf("2)Visualizza studenti\n");
                       printf("3)Inserimento prenotazione\n");
                       printf("4)Ricerca prenotazione\n");
                       printf("5)Salva su file prenotazioni\n");
                       printf("6)Leggi da file le prenotazioni\n");
                       printf("0)Fine\n");
                       scanf("%d",&scelta);
                       switch(scelta)
                       {
                                     case 1: leggi_studente (&s);
                                             ins_studente (&L[s.corso], s);
                                             break;
                                             
                                     case 2: printf("Corso da visualizzare: (0...3) ");
                                             scanf("%d",&i);
                                             vis_studenti (L[i]);
                                             break;
                                             
                                     case 3: leggi_prenotazione (&x);
                                             i=x.materia;
                                             ins_prenotazione (&T[i], &N[i], x);
                                             break;
                                             
                                     case 4: printf("Matricola: ");
                                             scanf("%ld",&matricola);
                                             printf("Codice materia: (0...9) ");
                                             scanf("%d",&i);
                                             ricerca (T[i], N[i], matricola);
                                             break;
                                             
                                     case 5: salva (T, N);
                                             break;
                                             
                                     case 6: leggi_file (T, N);
                                             break;
                                             
                                     default:;
                       }
      }while (scelta!=0);
      
      /* liberazione della memoria */
      for(i=0;i<4;i++)
          while(L[i]!=NULL)
               da_testa (&L[i]);
               
      for(i=0;i<10;i++)
          free(T[i]);
}


void leggi_studente (struct studente *s)
{
     printf("Cognome: ");
     scanf("%s",s->cognome);
     printf("Nome: ");
     scanf("%s",s->nome);
     printf("Matrciola: ");
     scanf("%ld",&s->matricola);
     printf("Codice corso di laurea (0...3) ");
     scanf("%d",&s->corso);
}

void ins_studente (struct atomo **ptl, struct studente s)
{
     struct atomo *a, *l1, *l2;
     
     a=malloc(sizeof(struct atomo));
     
     if(a==NULL)
        return;
        
     a->dato=s;
      
        
     if(*ptl==NULL || s.matricola<(*ptl)->dato.matricola)
      /* inserimento in testa*/
     {
                   a->next=*ptl;
                   *ptl=a;
                   return;
     }
     /* inserimento in posizione successiva alla prima*/
     l2=*ptl;
     l1=l2->next;
     
     while(l1!=NULL)
          if(s.matricola<l1->dato.matricola)
             break;
          else{
               l1=l1->next;
               l2=l2->next;
               }
               
     l2->next=a;
     a->next=l1;
}

void vis_studenti (struct atomo *ptl)
{
     struct atomo *l;
     
     l=ptl;
     
     while(l!=NULL)
     {
                   printf("Cognome: %s\n",l->dato.cognome);
                   printf("Nome: %s\n",l->dato.nome);
                   printf("Matricola: %ld\n\n",l->dato.matricola);
                   l=l->next;
     }
}

void leggi_prenotazione (struct prenotazione *p)
{
     printf("Matricola: ");
     scanf("%ld",&p->matricola);
     printf("Data esame: ");
     scanf("%s",p->data);
     printf("Codice corso di laurea: ");
     scanf("%d",&p->corso);
     printf("Codice materia: (0...9) ");
     scanf("%d",&p->materia);
}

void ins_prenotazione (struct prenotazione **R, int *n, struct prenotazione p)
{
     struct prenotazione *a;
     
     a=realloc(*R, (*n+1)*sizeof(struct prenotazione));
     
     if(a==NULL)
        return;
        
     *R=a;
     (*R)[*n]=p;
     (*n)++;
}

void ricerca (struct prenotazione *R, int n, long m)
{
     int i;
     
     for(i=0;i<n;i++)
         if(R[i].matricola==m)
           break;
     
     if(i<n) /* trovato*/
     {
            printf("\nData esame: %s\n",R[i].data);
            printf("Codice corso di laurea: %d\n\n",R[i].corso);
     }
     else printf("Matricola non trovata\n");
}

void salva (struct prenotazione *TB[10], int *N)
{
     FILE *pf;
     int i, j;
     
     pf=fopen("prenotazioni.dat","w");
     if(pf)
     {
           for(i=0;i<10;i++)
              for(j=0;j<N[i];j++)
                  fwrite(&TB[i][j],sizeof(struct prenotazione),1,pf);
                  
           fclose(pf);
     }
     else printf("Errore in scrittura\n");
}

void leggi_file (struct prenotazione *TB[10], int *N)
{
     FILE *pf;
     struct prenotazione temp;
     int i;
     
     pf=fopen("prenotazioni.dat","r");
     if(pf)
     {
           while(fread(&temp,sizeof(struct prenotazione),1,pf)>0)
           {
              i=temp.materia;
              ins_prenotazione (&TB[i], &N[i], temp);
           }
           fclose(pf);
     }
     else printf("Errore in lettura\n");
}

void da_testa (struct atomo **ptl)
{
     struct atomo *a;
     
     a=*ptl;
     *ptl=a->next;
     free(a);
}
     



            




     



                                     
